GLFW

- Documentation
- Download
- Media
- Community

- Main Page
- Related Pages
- Modules
- Data Structures
- Files

Typedefs | Functions
Window reference

## Typedefs
typedef struct GLFWwindow | GLFWwindow
| Opaque window object. More...
typedef void(* | GLFWwindowposfun) (GLFWwindow *, int, int)
| The function signature for window position callbacks. More...
typedef void(* | GLFWwindowsizefun) (GLFWwindow *, int, int)
| The function signature for window resize callbacks. More...
typedef void(* | GLFWwindowclosefun) (GLFWwindow *)
| The function signature for window close callbacks. More...
typedef void(* | GLFWwindowrefreshfun) (GLFWwindow *)
| The function signature for window content refresh callbacks. More...
typedef void(* | GLFWwindowfocusfun) (GLFWwindow *, int)
| The function signature for window focus/defocus callbacks. More...
typedef void(* | GLFWwindowiconifyfun) (GLFWwindow *, int)
| The function signature for window iconify/restore callbacks. More...
typedef void(* | GLFWframebuffersizefun) (GLFWwindow *, int, int)
| The function signature for framebuffer resize callbacks. More...

## Functions
void | glfwDefaultWindowHints (void)
| Resets all window hints to their default values. More...
void | glfwWindowHint (int hint, int value)
| Sets the specified window hint to the desired value. More...
GLFWwindow * | glfwCreateWindow (int width, int height, const char *title, GLFWmonitor *monitor, GLFWwindow *share)
| Creates a window and its associated context. More...
void | glfwDestroyWindow (GLFWwindow *window)
| Destroys the specified window and its context. More...
int | glfwWindowShouldClose (GLFWwindow *window)
| Checks the close flag of the specified window. More...
void | glfwSetWindowShouldClose (GLFWwindow *window, int value)
| Sets the close flag of the specified window. More...
void | glfwSetWindowTitle (GLFWwindow *window, const char *title)
| Sets the title of the specified window. More...
void | glfwSetWindowIcon (GLFWwindow *window, int count, const GLFWimage *images)
| Sets the icon for the specified window. More...
void | glfwGetWindowPos (GLFWwindow *window, int *xpos, int *ypos)
| Retrieves the position of the client area of the specified window. More...
void | glfwSetWindowPos (GLFWwindow *window, int xpos, int ypos)
| Sets the position of the client area of the specified window. More...
void | glfwGetWindowSize (GLFWwindow *window, int *width, int *height)
| Retrieves the size of the client area of the specified window. More...
void | glfwSetWindowSizeLimits (GLFWwindow *window, int minwidth, int minheight, int maxwidth, int maxheight)
| Sets the size limits of the specified window. More...
void | glfwSetWindowAspectRatio (GLFWwindow *window, int numer, int denom)
| Sets the aspect ratio of the specified window. More...
void | glfwSetWindowSize (GLFWwindow *window, int width, int height)
| Sets the size of the client area of the specified window. More...
void | glfwGetFramebufferSize (GLFWwindow *window, int *width, int *height)
| Retrieves the size of the framebuffer of the specified window. More...
void | glfwGetWindowFrameSize (GLFWwindow *window, int *left, int *top, int *right, int *bottom)
| Retrieves the size of the frame of the window. More...
void | glfwIconifyWindow (GLFWwindow *window)
| Iconifies the specified window. More...
void | glfwRestoreWindow (GLFWwindow *window)
| Restores the specified window. More...
void | glfwMaximizeWindow (GLFWwindow *window)
| Maximizes the specified window. More...
void | glfwShowWindow (GLFWwindow *window)
| Makes the specified window visible. More...
void | glfwHideWindow (GLFWwindow *window)
| Hides the specified window. More...
void | glfwFocusWindow (GLFWwindow *window)
| Brings the specified window to front and sets input focus. More...
GLFWmonitor * | glfwGetWindowMonitor (GLFWwindow *window)
| Returns the monitor that the window uses for full screen mode. More...
void | glfwSetWindowMonitor (GLFWwindow *window, GLFWmonitor *monitor, int xpos, int ypos, int width, int height, int refreshRate)
| Sets the mode, monitor, video mode and placement of a window. More...
int | glfwGetWindowAttrib (GLFWwindow *window, int attrib)
| Returns an attribute of the specified window. More...
void | glfwSetWindowUserPointer (GLFWwindow *window, void *pointer)
| Sets the user pointer of the specified window. More...
void * | glfwGetWindowUserPointer (GLFWwindow *window)
| Returns the user pointer of the specified window. More...
GLFWwindowposfun | glfwSetWindowPosCallback (GLFWwindow *window, GLFWwindowposfun cbfun)
| Sets the position callback for the specified window. More...
GLFWwindowsizefun | glfwSetWindowSizeCallback (GLFWwindow *window, GLFWwindowsizefun cbfun)
| Sets the size callback for the specified window. More...
GLFWwindowclosefun | glfwSetWindowCloseCallback (GLFWwindow *window, GLFWwindowclosefun cbfun)
| Sets the close callback for the specified window. More...
GLFWwindowrefreshfun | glfwSetWindowRefreshCallback (GLFWwindow *window, GLFWwindowrefreshfun cbfun)
| Sets the refresh callback for the specified window. More...
GLFWwindowfocusfun | glfwSetWindowFocusCallback (GLFWwindow *window, GLFWwindowfocusfun cbfun)
| Sets the focus callback for the specified window. More...
GLFWwindowiconifyfun | glfwSetWindowIconifyCallback (GLFWwindow *window, GLFWwindowiconifyfun cbfun)
| Sets the iconify callback for the specified window. More...
GLFWframebuffersizefun | glfwSetFramebufferSizeCallback (GLFWwindow *window, GLFWframebuffersizefun cbfun)
| Sets the framebuffer resize callback for the specified window. More...
void | glfwPollEvents (void)
| Processes all pending events. More...
void | glfwWaitEvents (void)
| Waits until events are queued and processes them. More...
void | glfwWaitEventsTimeout (double timeout)
| Waits with timeout until events are queued and processes them. More...
void | glfwPostEmptyEvent (void)
| Posts an empty event to the event queue. More...
void | glfwSwapBuffers (GLFWwindow *window)
| Swaps the front and back buffers of the specified window. More...

## Detailed Description

This is the reference documentation for window related functions and types, including creation, deletion and event polling. For more task-oriented information, see the Window guide.

## Typedef Documentation

typedef void(* GLFWframebuffersizefun) (GLFWwindow *, int, int)

This is the function signature for framebuffer resize callback functions.

Parameters

  [in] | window | The window whose framebuffer was resized.
  [in] | width | The new width, in pixels, of the framebuffer.
  [in] | height | The new height, in pixels, of the framebuffer.

See also
  Framebuffer size
  glfwSetFramebufferSizeCallback

Since
  Added in version 3.0.

typedef struct GLFWwindow GLFWwindow

Opaque window object.

See also
  Window objects

Since
  Added in version 3.0.

typedef void(* GLFWwindowclosefun) (GLFWwindow *)

This is the function signature for window close callback functions.

Parameters

  [in] | window | The window that the user attempted to close.

See also
  Window closing and close flag
  glfwSetWindowCloseCallback

Since
  Added in version 2.5.

  GLFW 3: Added window handle parameter.

typedef void(* GLFWwindowfocusfun) (GLFWwindow *, int)

This is the function signature for window focus callback functions.

Parameters

  [in] | window | The window that gained or lost input focus.
  [in] | focused | `GLFW_TRUE` if the window was given input focus, or `GLFW_FALSE` if it lost it.

See also
  Window input focus
  glfwSetWindowFocusCallback

Since
  Added in version 3.0.

typedef void(* GLFWwindowiconifyfun) (GLFWwindow *, int)

This is the function signature for window iconify/restore callback functions.

Parameters

  [in] | window | The window that was iconified or restored.
  [in] | iconified | `GLFW_TRUE` if the window was iconified, or `GLFW_FALSE` if it was restored.

See also
  Window iconification
  glfwSetWindowIconifyCallback

Since
  Added in version 3.0.

typedef void(* GLFWwindowposfun) (GLFWwindow *, int, int)

This is the function signature for window position callback functions.

Parameters

  [in] | window | The window that was moved.
  [in] | xpos | The new x-coordinate, in screen coordinates, of the upper-left corner of the client area of the window.
  [in] | ypos | The new y-coordinate, in screen coordinates, of the upper-left corner of the client area of the window.

See also
  Window position
  glfwSetWindowPosCallback

Since
  Added in version 3.0.

typedef void(* GLFWwindowrefreshfun) (GLFWwindow *)

This is the function signature for window refresh callback functions.

Parameters

  [in] | window | The window whose content needs to be refreshed.

See also
  Window damage and refresh
  glfwSetWindowRefreshCallback

Since
  Added in version 2.5.

  GLFW 3: Added window handle parameter.

typedef void(* GLFWwindowsizefun) (GLFWwindow *, int, int)

This is the function signature for window size callback functions.

Parameters

  [in] | window | The window that was resized.
  [in] | width | The new width, in screen coordinates, of the window.
  [in] | height | The new height, in screen coordinates, of the window.

See also
  Window size
  glfwSetWindowSizeCallback

Since
  Added in version 1.0.

  GLFW 3: Added window handle parameter.

## Function Documentation

GLFWwindow* glfwCreateWindow | ( | int | width,
|  | int | height,
|  | const char * | title,
|  | GLFWmonitor * | monitor,
|  | GLFWwindow * | share
| ) |  |

This function creates a window and its associated OpenGL or OpenGL ES context. Most of the options controlling how the window and its context should be created are specified with window hints.

Successful creation does not change which context is current. Before you can use the newly created context, you need to make it current. For information about the `share` parameter, see Context object sharing.

The created window, framebuffer and context may differ from what you requested, as not all parameters and hints are hard constraints. This includes the size of the window, especially for full screen windows. To query the actual attributes of the created window, framebuffer and context, see glfwGetWindowAttrib, glfwGetWindowSize and glfwGetFramebufferSize.

To create a full screen window, you need to specify the monitor the window will cover. If no monitor is specified, the window will be windowed mode. Unless you have a way for the user to choose a specific monitor, it is recommended that you pick the primary monitor. For more information on how to query connected monitors, see Retrieving monitors.

For full screen windows, the specified size becomes the resolution of the window's desired video mode. As long as a full screen window is not iconified, the supported video mode most closely matching the desired video mode is set for the specified monitor. For more information about full screen windows, including the creation of so called windowed full screen or borderless full screen windows, see "Windowed full screen" windows.

Once you have created the window, you can switch it between windowed and full screen mode with glfwSetWindowMonitor. If the window has an OpenGL or OpenGL ES context, it will be unaffected.

By default, newly created windows use the placement recommended by the window system. To create the window at a specific position, make it initially invisible using the GLFW_VISIBLE window hint, set its position and then show it.

As long as at least one full screen window is not iconified, the screensaver is prohibited from starting.

Window systems put limits on window sizes. Very large or very small window dimensions may be overridden by the window system on creation. Check the actual size after creation.

The swap interval is not set during window creation and the initial value may vary depending on driver settings and defaults.

Parameters

  [in] | width | The desired width, in screen coordinates, of the window. This must be greater than zero.
  [in] | height | The desired height, in screen coordinates, of the window. This must be greater than zero.
  [in] | title | The initial, UTF-8 encoded window title.
  [in] | monitor | The monitor to use for full screen mode, or `NULL` for windowed mode.
  [in] | share | The window whose context to share resources with, or `NULL` to not share resources.

Returns
  The handle of the created window, or `NULL` if an error occurred.

Errors
  Possible errors include GLFW_NOT_INITIALIZED, GLFW_INVALID_ENUM, GLFW_INVALID_VALUE, GLFW_API_UNAVAILABLE, GLFW_VERSION_UNAVAILABLE, GLFW_FORMAT_UNAVAILABLE and GLFW_PLATFORM_ERROR.

Remarks
  Windows: Window creation will fail if the Microsoft GDI software OpenGL implementation is the only one available.
  Windows: If the executable has an icon resource named `GLFW_ICON,` it will be set as the initial icon for the window. If no such icon is present, the `IDI_WINLOGO` icon will be used instead. To set a different icon, see glfwSetWindowIcon.
  Windows: The context to share resources with must not be current on any other thread.
  OS X: The GLFW window has no icon, as it is not a document window, but the dock icon will be the same as the application bundle's icon. For more information on bundles, see the Bundle Programming Guide in the Mac Developer Library.
  OS X: The first time a window is created the menu bar is populated with common commands like Hide, Quit and About. The About entry opens a minimal about dialog with information from the application's bundle. The menu bar can be disabled with a compile-time option.
  OS X: On OS X 10.10 and later the window frame will not be rendered at full resolution on Retina displays unless the `NSHighResolutionCapable` key is enabled in the application bundle's `Info.plist`. For more information, see High Resolution Guidelines for OS X in the Mac Developer Library. The GLFW test and example programs use a custom `Info.plist` template for this, which can be found as `CMake/MacOSXBundleInfo.plist.in` in the source tree.
  X11: Some window managers will not respect the placement of initially hidden windows.
  X11: Due to the asynchronous nature of X11, it may take a moment for a window to reach its requested state. This means you may not be able to query the final size, position or other attributes directly after window creation.

Reentrancy
  This function must not be called from a callback.

Thread safety
  This function must only be called from the main thread.

See also
  Window creation
  glfwDestroyWindow

Since
  Added in version 3.0. Replaces `glfwOpenWindow`.

void glfwDefaultWindowHints | ( | void |  | ) |

This function resets all window hints to their default values.

Errors
  Possible errors include GLFW_NOT_INITIALIZED.

Thread safety
  This function must only be called from the main thread.

See also
  Window creation hints
  glfwWindowHint

Since
  Added in version 3.0.

void glfwDestroyWindow | ( | GLFWwindow * | window | ) |

This function destroys the specified window and its context. On calling this function, no further callbacks will be called for that window.

If the context of the specified window is current on the main thread, it is detached before being destroyed.

Parameters

  [in] | window | The window to destroy.

Errors
  Possible errors include GLFW_NOT_INITIALIZED and GLFW_PLATFORM_ERROR.

Note
  The context of the specified window must not be current on any other thread when this function is called.

Reentrancy
  This function must not be called from a callback.

Thread safety
  This function must only be called from the main thread.

See also
  Window creation
  glfwCreateWindow

Since
  Added in version 3.0. Replaces `glfwCloseWindow`.

void glfwFocusWindow | ( | GLFWwindow * | window | ) |

This function brings the specified window to front and sets input focus. The window should already be visible and not iconified.

By default, both windowed and full screen mode windows are focused when initially created. Set the GLFW_FOCUSED to disable this behavior.

Do not use this function to steal focus from other applications unless you are certain that is what the user wants. Focus stealing can be extremely disruptive.

Parameters

  [in] | window | The window to give input focus.

Errors
  Possible errors include GLFW_NOT_INITIALIZED and GLFW_PLATFORM_ERROR.

Thread safety
  This function must only be called from the main thread.

See also
  Window input focus

Since
  Added in version 3.2.

void glfwGetFramebufferSize | ( | GLFWwindow * | window,
|  | int * | width,
|  | int * | height
| ) |  |

This function retrieves the size, in pixels, of the framebuffer of the specified window. If you wish to retrieve the size of the window in screen coordinates, see glfwGetWindowSize.

Any or all of the size arguments may be `NULL`. If an error occurs, all non-`NULL` size arguments will be set to zero.

Parameters

  [in] | window | The window whose framebuffer to query.
  [out] | width | Where to store the width, in pixels, of the framebuffer, or `NULL`.
  [out] | height | Where to store the height, in pixels, of the framebuffer, or `NULL`.

Errors
  Possible errors include GLFW_NOT_INITIALIZED and GLFW_PLATFORM_ERROR.

Thread safety
  This function must only be called from the main thread.

See also
  Framebuffer size
  glfwSetFramebufferSizeCallback

Since
  Added in version 3.0.

int glfwGetWindowAttrib | ( | GLFWwindow * | window,
|  | int | attrib
| ) |  |

This function returns the value of an attribute of the specified window or its OpenGL or OpenGL ES context.

Parameters

  [in] | window | The window to query.
  [in] | attrib | The window attribute whose value to return.

Returns
  The value of the attribute, or zero if an error occurred.

Errors
  Possible errors include GLFW_NOT_INITIALIZED, GLFW_INVALID_ENUM and GLFW_PLATFORM_ERROR.

Remarks
  Framebuffer related hints are not window attributes. See Framebuffer related attributes for more information.
  Zero is a valid value for many window and context related attributes so you cannot use a return value of zero as an indication of errors. However, this function should not fail as long as it is passed valid arguments and the library has been initialized.

Thread safety
  This function must only be called from the main thread.

See also
  Window attributes

Since
  Added in version 3.0. Replaces `glfwGetWindowParam` and `glfwGetGLVersion`.

void glfwGetWindowFrameSize | ( | GLFWwindow * | window,
|  | int * | left,
|  | int * | top,
|  | int * | right,
|  | int * | bottom
| ) |  |

This function retrieves the size, in screen coordinates, of each edge of the frame of the specified window. This size includes the title bar, if the window has one. The size of the frame may vary depending on the window-related hints used to create it.

Because this function retrieves the size of each window frame edge and not the offset along a particular coordinate axis, the retrieved values will always be zero or positive.

Any or all of the size arguments may be `NULL`. If an error occurs, all non-`NULL` size arguments will be set to zero.

Parameters

  [in] | window | The window whose frame size to query.
  [out] | left | Where to store the size, in screen coordinates, of the left edge of the window frame, or `NULL`.
  [out] | top | Where to store the size, in screen coordinates, of the top edge of the window frame, or `NULL`.
  [out] | right | Where to store the size, in screen coordinates, of the right edge of the window frame, or `NULL`.
  [out] | bottom | Where to store the size, in screen coordinates, of the bottom edge of the window frame, or `NULL`.

Errors
  Possible errors include GLFW_NOT_INITIALIZED and GLFW_PLATFORM_ERROR.

Thread safety
  This function must only be called from the main thread.

See also
  Window size

Since
  Added in version 3.1.

GLFWmonitor* glfwGetWindowMonitor | ( | GLFWwindow * | window | ) |

This function returns the handle of the monitor that the specified window is in full screen on.

Parameters

  [in] | window | The window to query.

Returns
  The monitor, or `NULL` if the window is in windowed mode or an error occurred.

Errors
  Possible errors include GLFW_NOT_INITIALIZED.

Thread safety
  This function must only be called from the main thread.

See also
  Window monitor
  glfwSetWindowMonitor

Since
  Added in version 3.0.

void glfwGetWindowPos | ( | GLFWwindow * | window,
|  | int * | xpos,
|  | int * | ypos
| ) |  |

This function retrieves the position, in screen coordinates, of the upper-left corner of the client area of the specified window.

Any or all of the position arguments may be `NULL`. If an error occurs, all non-`NULL` position arguments will be set to zero.

Parameters

  [in] | window | The window to query.
  [out] | xpos | Where to store the x-coordinate of the upper-left corner of the client area, or `NULL`.
  [out] | ypos | Where to store the y-coordinate of the upper-left corner of the client area, or `NULL`.

Errors
  Possible errors include GLFW_NOT_INITIALIZED and GLFW_PLATFORM_ERROR.

Thread safety
  This function must only be called from the main thread.

See also
  Window position
  glfwSetWindowPos

Since
  Added in version 3.0.

void glfwGetWindowSize | ( | GLFWwindow * | window,
|  | int * | width,
|  | int * | height
| ) |  |

This function retrieves the size, in screen coordinates, of the client area of the specified window. If you wish to retrieve the size of the framebuffer of the window in pixels, see glfwGetFramebufferSize.

Any or all of the size arguments may be `NULL`. If an error occurs, all non-`NULL` size arguments will be set to zero.

Parameters

  [in] | window | The window whose size to retrieve.
  [out] | width | Where to store the width, in screen coordinates, of the client area, or `NULL`.
  [out] | height | Where to store the height, in screen coordinates, of the client area, or `NULL`.

Errors
  Possible errors include GLFW_NOT_INITIALIZED and GLFW_PLATFORM_ERROR.

Thread safety
  This function must only be called from the main thread.

See also
  Window size
  glfwSetWindowSize

Since
  Added in version 1.0.

  GLFW 3: Added window handle parameter.

void* glfwGetWindowUserPointer | ( | GLFWwindow * | window | ) |

This function returns the current value of the user-defined pointer of the specified window. The initial value is `NULL`.

Parameters

  [in] | window | The window whose pointer to return.

Errors
  Possible errors include GLFW_NOT_INITIALIZED.

Thread safety
  This function may be called from any thread. Access is not synchronized.

See also
  User pointer
  glfwSetWindowUserPointer

Since
  Added in version 3.0.

void glfwHideWindow | ( | GLFWwindow * | window | ) |

This function hides the specified window if it was previously visible. If the window is already hidden or is in full screen mode, this function does nothing.

Parameters

  [in] | window | The window to hide.

Errors
  Possible errors include GLFW_NOT_INITIALIZED and GLFW_PLATFORM_ERROR.

Thread safety
  This function must only be called from the main thread.

See also
  Window visibility
  glfwShowWindow

Since
  Added in version 3.0.

void glfwIconifyWindow | ( | GLFWwindow * | window | ) |

This function iconifies (minimizes) the specified window if it was previously restored. If the window is already iconified, this function does nothing.

If the specified window is a full screen window, the original monitor resolution is restored until the window is restored.

Parameters

  [in] | window | The window to iconify.

Errors
  Possible errors include GLFW_NOT_INITIALIZED and GLFW_PLATFORM_ERROR.

Thread safety
  This function must only be called from the main thread.

See also
  Window iconification
  glfwRestoreWindow
  glfwMaximizeWindow

Since
  Added in version 2.1.

  GLFW 3: Added window handle parameter.

void glfwMaximizeWindow | ( | GLFWwindow * | window | ) |

This function maximizes the specified window if it was previously not maximized. If the window is already maximized, this function does nothing.

If the specified window is a full screen window, this function does nothing.

Parameters

  [in] | window | The window to maximize.

Errors
  Possible errors include GLFW_NOT_INITIALIZED and GLFW_PLATFORM_ERROR.

Thread Safety
  This function may only be called from the main thread.

See also
  Window iconification
  glfwIconifyWindow
  glfwRestoreWindow

Since
  Added in GLFW 3.2.

void glfwPollEvents | ( | void |  | ) |

This function processes only those events that are already in the event queue and then returns immediately. Processing events will cause the window and input callbacks associated with those events to be called.

On some platforms, a window move, resize or menu operation will cause event processing to block. This is due to how event processing is designed on those platforms. You can use the window refresh callback to redraw the contents of your window when necessary during such operations.

On some platforms, certain events are sent directly to the application without going through the event queue, causing callbacks to be called outside of a call to one of the event processing functions.

Event processing is not required for joystick input to work.

Errors
  Possible errors include GLFW_NOT_INITIALIZED and GLFW_PLATFORM_ERROR.

Reentrancy
  This function must not be called from a callback.

Thread safety
  This function must only be called from the main thread.

See also
  Event processing
  glfwWaitEvents
  glfwWaitEventsTimeout

Since
  Added in version 1.0.

void glfwPostEmptyEvent | ( | void |  | ) |

This function posts an empty event from the current thread to the event queue, causing glfwWaitEvents or glfwWaitEventsTimeout to return.

If no windows exist, this function returns immediately. For synchronization of threads in applications that do not create windows, use your threading library of choice.

Errors
  Possible errors include GLFW_NOT_INITIALIZED and GLFW_PLATFORM_ERROR.

Thread safety
  This function may be called from any thread.

See also
  Event processing
  glfwWaitEvents
  glfwWaitEventsTimeout

Since
  Added in version 3.1.

void glfwRestoreWindow | ( | GLFWwindow * | window | ) |

This function restores the specified window if it was previously iconified (minimized) or maximized. If the window is already restored, this function does nothing.

If the specified window is a full screen window, the resolution chosen for the window is restored on the selected monitor.

Parameters

  [in] | window | The window to restore.

Errors
  Possible errors include GLFW_NOT_INITIALIZED and GLFW_PLATFORM_ERROR.

Thread safety
  This function must only be called from the main thread.

See also
  Window iconification
  glfwIconifyWindow
  glfwMaximizeWindow

Since
  Added in version 2.1.

  GLFW 3: Added window handle parameter.

GLFWframebuffersizefun glfwSetFramebufferSizeCallback | ( | GLFWwindow * | window,
|  | GLFWframebuffersizefun | cbfun
| ) |  |

This function sets the framebuffer resize callback of the specified window, which is called when the framebuffer of the specified window is resized.

Parameters

  [in] | window | The window whose callback to set.
  [in] | cbfun | The new callback, or `NULL` to remove the currently set callback.

Returns
  The previously set callback, or `NULL` if no callback was set or the library had not been initialized.

Errors
  Possible errors include GLFW_NOT_INITIALIZED.

Thread safety
  This function must only be called from the main thread.

See also
  Framebuffer size

Since
  Added in version 3.0.

void glfwSetWindowAspectRatio | ( | GLFWwindow * | window,
|  | int | numer,
|  | int | denom
| ) |  |

This function sets the required aspect ratio of the client area of the specified window. If the window is full screen, the aspect ratio only takes effect once it is made windowed. If the window is not resizable, this function does nothing.

The aspect ratio is specified as a numerator and a denominator and both values must be greater than zero. For example, the common 16:9 aspect ratio is specified as 16 and 9, respectively.

If the numerator and denominator is set to `GLFW_DONT_CARE` then the aspect ratio limit is disabled.

The aspect ratio is applied immediately to a windowed mode window and may cause it to be resized.

Parameters

  [in] | window | The window to set limits for.
  [in] | numer | The numerator of the desired aspect ratio, or `GLFW_DONT_CARE`.
  [in] | denom | The denominator of the desired aspect ratio, or `GLFW_DONT_CARE`.

Errors
  Possible errors include GLFW_NOT_INITIALIZED, GLFW_INVALID_VALUE and GLFW_PLATFORM_ERROR.

Remarks
  If you set size limits and an aspect ratio that conflict, the results are undefined.

Thread safety
  This function must only be called from the main thread.

See also
  Window size limits
  glfwSetWindowSizeLimits

Since
  Added in version 3.2.

GLFWwindowclosefun glfwSetWindowCloseCallback | ( | GLFWwindow * | window,
|  | GLFWwindowclosefun | cbfun
| ) |  |

This function sets the close callback of the specified window, which is called when the user attempts to close the window, for example by clicking the close widget in the title bar.

The close flag is set before this callback is called, but you can modify it at any time with glfwSetWindowShouldClose.

The close callback is not triggered by glfwDestroyWindow.

Parameters

  [in] | window | The window whose callback to set.
  [in] | cbfun | The new callback, or `NULL` to remove the currently set callback.

Returns
  The previously set callback, or `NULL` if no callback was set or the library had not been initialized.

Errors
  Possible errors include GLFW_NOT_INITIALIZED.

Remarks
  OS X: Selecting Quit from the application menu will trigger the close callback for all windows.

Thread safety
  This function must only be called from the main thread.

See also
  Window closing and close flag

Since
  Added in version 2.5.

  GLFW 3: Added window handle parameter and return value.

GLFWwindowfocusfun glfwSetWindowFocusCallback | ( | GLFWwindow * | window,
|  | GLFWwindowfocusfun | cbfun
| ) |  |

This function sets the focus callback of the specified window, which is called when the window gains or loses input focus.

After the focus callback is called for a window that lost input focus, synthetic key and mouse button release events will be generated for all such that had been pressed. For more information, see glfwSetKeyCallback and glfwSetMouseButtonCallback.

Parameters

  [in] | window | The window whose callback to set.
  [in] | cbfun | The new callback, or `NULL` to remove the currently set callback.

Returns
  The previously set callback, or `NULL` if no callback was set or the library had not been initialized.

Errors
  Possible errors include GLFW_NOT_INITIALIZED.

Thread safety
  This function must only be called from the main thread.

See also
  Window input focus

Since
  Added in version 3.0.

void glfwSetWindowIcon | ( | GLFWwindow * | window,
|  | int | count,
|  | const GLFWimage * | images
| ) |  |

This function sets the icon of the specified window. If passed an array of candidate images, those of or closest to the sizes desired by the system are selected. If no images are specified, the window reverts to its default icon.

The desired image sizes varies depending on platform and system settings. The selected images will be rescaled as needed. Good sizes include 16x16, 32x32 and 48x48.

Parameters

  [in] | window | The window whose icon to set.
  [in] | count | The number of images in the specified array, or zero to revert to the default window icon.
  [in] | images | The images to create the icon from. This is ignored if count is zero.

Errors
  Possible errors include GLFW_NOT_INITIALIZED and GLFW_PLATFORM_ERROR.

Pointer lifetime
  The specified image data is copied before this function returns.

Remarks
  OS X: The GLFW window has no icon, as it is not a document window, so this function does nothing. The dock icon will be the same as the application bundle's icon. For more information on bundles, see the Bundle Programming Guide in the Mac Developer Library.

Thread safety
  This function must only be called from the main thread.

See also
  Window icon

Since
  Added in version 3.2.

GLFWwindowiconifyfun glfwSetWindowIconifyCallback | ( | GLFWwindow * | window,
|  | GLFWwindowiconifyfun | cbfun
| ) |  |

This function sets the iconification callback of the specified window, which is called when the window is iconified or restored.

Parameters

  [in] | window | The window whose callback to set.
  [in] | cbfun | The new callback, or `NULL` to remove the currently set callback.

Returns
  The previously set callback, or `NULL` if no callback was set or the library had not been initialized.

Errors
  Possible errors include GLFW_NOT_INITIALIZED.

Thread safety
  This function must only be called from the main thread.

See also
  Window iconification

Since
  Added in version 3.0.

void glfwSetWindowMonitor | ( | GLFWwindow * | window,
|  | GLFWmonitor * | monitor,
|  | int | xpos,
|  | int | ypos,
|  | int | width,
|  | int | height,
|  | int | refreshRate
| ) |  |

This function sets the monitor that the window uses for full screen mode or, if the monitor is `NULL`, makes it windowed mode.

When setting a monitor, this function updates the width, height and refresh rate of the desired video mode and switches to the video mode closest to it. The window position is ignored when setting a monitor.

When the monitor is `NULL`, the position, width and height are used to place the window client area. The refresh rate is ignored when no monitor is specified.

If you only wish to update the resolution of a full screen window or the size of a windowed mode window, see glfwSetWindowSize.

When a window transitions from full screen to windowed mode, this function restores any previous window settings such as whether it is decorated, floating, resizable, has size or aspect ratio limits, etc..

Parameters

  [in] | window | The window whose monitor, size or video mode to set.
  [in] | monitor | The desired monitor, or `NULL` to set windowed mode.
  [in] | xpos | The desired x-coordinate of the upper-left corner of the client area.
  [in] | ypos | The desired y-coordinate of the upper-left corner of the client area.
  [in] | width | The desired with, in screen coordinates, of the client area or video mode.
  [in] | height | The desired height, in screen coordinates, of the client area or video mode.
  [in] | refreshRate | The desired refresh rate, in Hz, of the video mode, or `GLFW_DONT_CARE`.

Errors
  Possible errors include GLFW_NOT_INITIALIZED and GLFW_PLATFORM_ERROR.

Thread safety
  This function must only be called from the main thread.

See also
  Window monitor
  Full screen windows
  glfwGetWindowMonitor
  glfwSetWindowSize

Since
  Added in version 3.2.

void glfwSetWindowPos | ( | GLFWwindow * | window,
|  | int | xpos,
|  | int | ypos
| ) |  |

This function sets the position, in screen coordinates, of the upper-left corner of the client area of the specified windowed mode window. If the window is a full screen window, this function does nothing.

Do not use this function to move an already visible window unless you have very good reasons for doing so, as it will confuse and annoy the user.

The window manager may put limits on what positions are allowed. GLFW cannot and should not override these limits.

Parameters

  [in] | window | The window to query.
  [in] | xpos | The x-coordinate of the upper-left corner of the client area.
  [in] | ypos | The y-coordinate of the upper-left corner of the client area.

Errors
  Possible errors include GLFW_NOT_INITIALIZED and GLFW_PLATFORM_ERROR.

Thread safety
  This function must only be called from the main thread.

See also
  Window position
  glfwGetWindowPos

Since
  Added in version 1.0.

  GLFW 3: Added window handle parameter.

GLFWwindowposfun glfwSetWindowPosCallback | ( | GLFWwindow * | window,
|  | GLFWwindowposfun | cbfun
| ) |  |

This function sets the position callback of the specified window, which is called when the window is moved. The callback is provided with the screen position of the upper-left corner of the client area of the window.

Parameters

  [in] | window | The window whose callback to set.
  [in] | cbfun | The new callback, or `NULL` to remove the currently set callback.

Returns
  The previously set callback, or `NULL` if no callback was set or the library had not been initialized.

Errors
  Possible errors include GLFW_NOT_INITIALIZED.

Thread safety
  This function must only be called from the main thread.

See also
  Window position

Since
  Added in version 3.0.

GLFWwindowrefreshfun glfwSetWindowRefreshCallback | ( | GLFWwindow * | window,
|  | GLFWwindowrefreshfun | cbfun
| ) |  |

This function sets the refresh callback of the specified window, which is called when the client area of the window needs to be redrawn, for example if the window has been exposed after having been covered by another window.

On compositing window systems such as Aero, Compiz or Aqua, where the window contents are saved off-screen, this callback may be called only very infrequently or never at all.

Parameters

  [in] | window | The window whose callback to set.
  [in] | cbfun | The new callback, or `NULL` to remove the currently set callback.

Returns
  The previously set callback, or `NULL` if no callback was set or the library had not been initialized.

Errors
  Possible errors include GLFW_NOT_INITIALIZED.

Thread safety
  This function must only be called from the main thread.

See also
  Window damage and refresh

Since
  Added in version 2.5.

  GLFW 3: Added window handle parameter and return value.

void glfwSetWindowShouldClose | ( | GLFWwindow * | window,
|  | int | value
| ) |  |

This function sets the value of the close flag of the specified window. This can be used to override the user's attempt to close the window, or to signal that it should be closed.

Parameters

  [in] | window | The window whose flag to change.
  [in] | value | The new value.

Errors
  Possible errors include GLFW_NOT_INITIALIZED.

Thread safety
  This function may be called from any thread. Access is not synchronized.

See also
  Window closing and close flag

Since
  Added in version 3.0.

void glfwSetWindowSize | ( | GLFWwindow * | window,
|  | int | width,
|  | int | height
| ) |  |

This function sets the size, in screen coordinates, of the client area of the specified window.

For full screen windows, this function updates the resolution of its desired video mode and switches to the video mode closest to it, without affecting the window's context. As the context is unaffected, the bit depths of the framebuffer remain unchanged.

If you wish to update the refresh rate of the desired video mode in addition to its resolution, see glfwSetWindowMonitor.

The window manager may put limits on what sizes are allowed. GLFW cannot and should not override these limits.

Parameters

  [in] | window | The window to resize.
  [in] | width | The desired width, in screen coordinates, of the window client area.
  [in] | height | The desired height, in screen coordinates, of the window client area.

Errors
  Possible errors include GLFW_NOT_INITIALIZED and GLFW_PLATFORM_ERROR.

Thread safety
  This function must only be called from the main thread.

See also
  Window size
  glfwGetWindowSize
  glfwSetWindowMonitor

Since
  Added in version 1.0.

  GLFW 3: Added window handle parameter.

GLFWwindowsizefun glfwSetWindowSizeCallback | ( | GLFWwindow * | window,
|  | GLFWwindowsizefun | cbfun
| ) |  |

This function sets the size callback of the specified window, which is called when the window is resized. The callback is provided with the size, in screen coordinates, of the client area of the window.

Parameters

  [in] | window | The window whose callback to set.
  [in] | cbfun | The new callback, or `NULL` to remove the currently set callback.

Returns
  The previously set callback, or `NULL` if no callback was set or the library had not been initialized.

Errors
  Possible errors include GLFW_NOT_INITIALIZED.

Thread safety
  This function must only be called from the main thread.

See also
  Window size

Since
  Added in version 1.0.

  GLFW 3: Added window handle parameter and return value.

void glfwSetWindowSizeLimits | ( | GLFWwindow * | window,
|  | int | minwidth,
|  | int | minheight,
|  | int | maxwidth,
|  | int | maxheight
| ) |  |

This function sets the size limits of the client area of the specified window. If the window is full screen, the size limits only take effect once it is made windowed. If the window is not resizable, this function does nothing.

The size limits are applied immediately to a windowed mode window and may cause it to be resized.

The maximum dimensions must be greater than or equal to the minimum dimensions and all must be greater than or equal to zero.

Parameters

  [in] | window | The window to set limits for.
  [in] | minwidth | The minimum width, in screen coordinates, of the client area, or `GLFW_DONT_CARE`.
  [in] | minheight | The minimum height, in screen coordinates, of the client area, or `GLFW_DONT_CARE`.
  [in] | maxwidth | The maximum width, in screen coordinates, of the client area, or `GLFW_DONT_CARE`.
  [in] | maxheight | The maximum height, in screen coordinates, of the client area, or `GLFW_DONT_CARE`.

Errors
  Possible errors include GLFW_NOT_INITIALIZED, GLFW_INVALID_VALUE and GLFW_PLATFORM_ERROR.

Remarks
  If you set size limits and an aspect ratio that conflict, the results are undefined.

Thread safety
  This function must only be called from the main thread.

See also
  Window size limits
  glfwSetWindowAspectRatio

Since
  Added in version 3.2.

void glfwSetWindowTitle | ( | GLFWwindow * | window,
|  | const char * | title
| ) |  |

This function sets the window title, encoded as UTF-8, of the specified window.

Parameters

  [in] | window | The window whose title to change.
  [in] | title | The UTF-8 encoded window title.

Errors
  Possible errors include GLFW_NOT_INITIALIZED and GLFW_PLATFORM_ERROR.

Remarks
  OS X: The window title will not be updated until the next time you process events.

Thread safety
  This function must only be called from the main thread.

See also
  Window title

Since
  Added in version 1.0.

  GLFW 3: Added window handle parameter.

void glfwSetWindowUserPointer | ( | GLFWwindow * | window,
|  | void * | pointer
| ) |  |

This function sets the user-defined pointer of the specified window. The current value is retained until the window is destroyed. The initial value is `NULL`.

Parameters

  [in] | window | The window whose pointer to set.
  [in] | pointer | The new value.

Errors
  Possible errors include GLFW_NOT_INITIALIZED.

Thread safety
  This function may be called from any thread. Access is not synchronized.

See also
  User pointer
  glfwGetWindowUserPointer

Since
  Added in version 3.0.

void glfwShowWindow | ( | GLFWwindow * | window | ) |

This function makes the specified window visible if it was previously hidden. If the window is already visible or is in full screen mode, this function does nothing.

Parameters

  [in] | window | The window to make visible.

Errors
  Possible errors include GLFW_NOT_INITIALIZED and GLFW_PLATFORM_ERROR.

Thread safety
  This function must only be called from the main thread.

See also
  Window visibility
  glfwHideWindow

Since
  Added in version 3.0.

void glfwSwapBuffers | ( | GLFWwindow * | window | ) |

This function swaps the front and back buffers of the specified window when rendering with OpenGL or OpenGL ES. If the swap interval is greater than zero, the GPU driver waits the specified number of screen updates before swapping the buffers.

The specified window must have an OpenGL or OpenGL ES context. Specifying a window without a context will generate a GLFW_NO_WINDOW_CONTEXT error.

This function does not apply to Vulkan. If you are rendering with Vulkan, see `vkQueuePresentKHR` instead.

Parameters

  [in] | window | The window whose buffers to swap.

Errors
  Possible errors include GLFW_NOT_INITIALIZED, GLFW_NO_WINDOW_CONTEXT and GLFW_PLATFORM_ERROR.

Remarks
  EGL: The context of the specified window must be current on the calling thread.

Thread safety
  This function may be called from any thread.

See also
  Buffer swapping
  glfwSwapInterval

Since
  Added in version 1.0.

  GLFW 3: Added window handle parameter.

void glfwWaitEvents | ( | void |  | ) |

This function puts the calling thread to sleep until at least one event is available in the event queue. Once one or more events are available, it behaves exactly like glfwPollEvents, i.e. the events in the queue are processed and the function then returns immediately. Processing events will cause the window and input callbacks associated with those events to be called.

Since not all events are associated with callbacks, this function may return without a callback having been called even if you are monitoring all callbacks.

On some platforms, a window move, resize or menu operation will cause event processing to block. This is due to how event processing is designed on those platforms. You can use the window refresh callback to redraw the contents of your window when necessary during such operations.

On some platforms, certain callbacks may be called outside of a call to one of the event processing functions.

If no windows exist, this function returns immediately. For synchronization of threads in applications that do not create windows, use your threading library of choice.

Event processing is not required for joystick input to work.

Errors
  Possible errors include GLFW_NOT_INITIALIZED and GLFW_PLATFORM_ERROR.

Reentrancy
  This function must not be called from a callback.

Thread safety
  This function must only be called from the main thread.

See also
  Event processing
  glfwPollEvents
  glfwWaitEventsTimeout

Since
  Added in version 2.5.

void glfwWaitEventsTimeout | ( | double | timeout | ) |

This function puts the calling thread to sleep until at least one event is available in the event queue, or until the specified timeout is reached. If one or more events are available, it behaves exactly like glfwPollEvents, i.e. the events in the queue are processed and the function then returns immediately. Processing events will cause the window and input callbacks associated with those events to be called.

The timeout value must be a positive finite number.

Since not all events are associated with callbacks, this function may return without a callback having been called even if you are monitoring all callbacks.

On some platforms, a window move, resize or menu operation will cause event processing to block. This is due to how event processing is designed on those platforms. You can use the window refresh callback to redraw the contents of your window when necessary during such operations.

On some platforms, certain callbacks may be called outside of a call to one of the event processing functions.

If no windows exist, this function returns immediately. For synchronization of threads in applications that do not create windows, use your threading library of choice.

Event processing is not required for joystick input to work.

Parameters

  [in] | timeout | The maximum amount of time, in seconds, to wait.

Reentrancy
  This function must not be called from a callback.

Thread safety
  This function must only be called from the main thread.

See also
  Event processing
  glfwPollEvents
  glfwWaitEvents

Since
  Added in version 3.2.

void glfwWindowHint | ( | int | hint,
|  | int | value
| ) |  |

This function sets hints for the next call to glfwCreateWindow. The hints, once set, retain their values until changed by a call to glfwWindowHint or glfwDefaultWindowHints, or until the library is terminated.

This function does not check whether the specified hint values are valid. If you set hints to invalid values this will instead be reported by the next call to glfwCreateWindow.

Parameters

  [in] | hint | The window hint to set.
  [in] | value | The new value of the window hint.

Errors
  Possible errors include GLFW_NOT_INITIALIZED and GLFW_INVALID_ENUM.

Thread safety
  This function must only be called from the main thread.

See also
  Window creation hints
  glfwDefaultWindowHints

Since
  Added in version 3.0. Replaces `glfwOpenWindowHint`.

int glfwWindowShouldClose | ( | GLFWwindow * | window | ) |

This function returns the value of the close flag of the specified window.

Parameters

  [in] | window | The window to query.

Returns
  The value of the close flag.

Errors
  Possible errors include GLFW_NOT_INITIALIZED.

Thread safety
  This function may be called from any thread. Access is not synchronized.

See also
  Window closing and close flag

Since
  Added in version 3.0.